<template>
  <div class="upload">
    <div class="upload-list">
      <div class="upload-list__item">
        <span>{{ downloadTitle }}</span>
        <button
            data-qa="btnUploadList"
            class="upload-list__button"
            @click="downloadTemplate"
        >
          <span v-if="!isLoading">
            <i  class="icon download" />
            <span >{{ downloadLinkTitle }}</span>
          </span>
          <span v-else
                class="upload-list__button--loader">
            <ob-loader/>
          </span>
        </button>
      </div>
    </div>
    <div v-if="isDownload">
      <div class="upload-list__item mb-10" >
        {{ uploadTitle }}
      </div>
      <ObUploader
          :isReadOnly="order.orderStatus !== STEP.ALLOCATED"
          @change="onChange"
          ref="uploader"
      />
    </div>
  </div>
</template>

<script>
import ObUploader from 'common-components/src/obComponents/obUploader'
import ObLoader from 'common-components/src/obComponents/obLoader'
import {mapGetters} from "vuex";
import STEPS from '@/constants/steps.js';
import api from "@/api";

export default {
  components: {
    ObUploader,
    ObLoader
  },
  props: {
    downloadTitle: {
      type: String,
      default: ''
    },
    downloadLinkTitle: {
      type: String,
      default: ''
    },
    uploadTitle: {
      type: String,
      default: ''
    }

  },
  data() {
    return {
      STEP: STEPS,
      isLoading: false,
      isDownload: false
    }
  },
  computed: {
    ...mapGetters({
      order: 'account/order'
    })
  },
  mounted() {
    if (this.order.orderStatus === this.STEP.ALLOCATED) {
      this.$refs.uploader.$el.scrollIntoView()
    }
  },
  methods: {
    onChange(data) {
      this.$emit('change', data)
    },
    async downloadTemplate () {
      try {
        this.isLoading = true
        await api.orderProcess.getOrderRequestTemplate({ uuid: this.order.suborderUuid })
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки файла'
        })
      } finally {
        this.isDownload = true
        this.isLoading = false
      }
    }
  }
}
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

.upload {
  padding-top: 10px;
  .upload-list {

    &__item {
      display: flex;
      flex-direction: column;
      @include font-mixin(16px, 20px, 400, $color-grey-label);
      &.mb-10{
        margin-bottom: 10px;
      }
    }
    &__button {
      display: flex;
      align-items: center;
      border: none;
      margin: 15px 0 25px;
      background-color: transparent;
      outline: none;
      cursor: pointer;
      color: $color-blue-navy-blue;
      @include font-mixin(16px, 20px, 400, $color-blue-navy-blue);
      .icon {
        font-size: 15px;
        margin-right: 6px;
      }
      span {
        &.upload-list__button--loader{
          margin: 0 auto;
        }
      }
    }
  }
}
  ::v-deep .loader{
    width: 20px!important;
    height: 20px!important;
  }
</style>